%define shared_desktop_ontologies_ver 0.11.0
%define soprano_ver 2.9.3

%global shared_desktop_ontologies_version %(pkg-config --modversion shared-desktop-ontologies 2>/dev/null || echo %{shared_desktop_ontologies_ver})
%global soprano_version %(pkg-config --modversion soprano 2>/dev/null || echo %{soprano_ver})

# enable tests (they're disabled by default)
#global tests 1
%if 0%{?tests}
%global _kde4_build_tests -DKDE4_BUILD_TESTS:BOOL=ON
%endif
## mobipocket support
#global mobi 1

Name:    nepomuk-core
Version: 4.14.3
Release: 1%{?dist}
Summary: Nepomuk Core utilities and libraries

License: LGPLv2 or LGPLv3
URL:     http://www.kde.org/

%global revision %(echo %{version} | cut -d. -f3)
%if %{revision} >= 50
%global stable unstable
%else
%global stable stable
%endif
Source0: http://download.kde.org/%{stable}/%{version}/src/%{name}-%{version}.tar.xz

## upstream patches

BuildRequires: baloo-devel >= %{version}
BuildRequires: ebook-tools-devel
BuildRequires: kdelibs4-devel >= %{version}
BuildRequires: kfilemetadata-devel >= %{version}
BuildRequires: pkgconfig
BuildRequires: pkgconfig(soprano) >= %{soprano_ver}
BuildRequires: pkgconfig(libstreamanalyzer) pkgconfig(libstreams)
BuildRequires: pkgconfig(shared-desktop-ontologies)
# fileindexer plugins
BuildRequires: pkgconfig(exiv2) >= 0.20
BuildRequires: pkgconfig(poppler-qt4)
BuildRequires: pkgconfig(taglib)
# for %%{_polkit_qt_policydir} macro
BuildRequires: polkit-qt-devel
%if 0%{?mobi}
BuildRequires: qmobipocket-devel >= %{version}
%endif
%if  0%{?tests}
BuildRequires: dbus-x11
BuildRequires: procps
BuildRequires: virtuoso-opensource
BuildRequires: xorg-x11-server-Xvfb
%endif

# help upgrade path to baloo
Obsoletes: nepomuk-core < 4.13.0-2

Requires: %{name}-libs%{?_isa} = %{version}-%{release}
Requires: kdelibs4%{?_isa} >= %{version}
Requires: shared-desktop-ontologies >= %{shared_desktop_ontologies_version}
Provides: soprano-backend-virtuoso >= %{soprano_version}
Requires: virtuoso-opensource >= 6.1.6

# moved from kde-runtime in 4.8.80 (nepomuk common has nepomuk-core preference)
Conflicts: kde-runtime < 4.8.80-2

%description
%{summary}.

%package devel
Summary:  Developer files for %{name}
Requires: %{name}-libs%{?_isa} = %{version}-%{release}
Requires: kdelibs4-devel
%description devel
%{summary}.

%package libs
Summary:  Runtime libraries for %{name}
Requires: kdelibs4%{?_isa} >= %{version}
Requires: %{name} = %{version}-%{release}
%description libs
%{summary}.


%prep
%setup -q


%build
mkdir -p %{_target_platform}
pushd %{_target_platform}
%{cmake_kde4} ..
popd

make %{?_smp_mflags} -C %{_target_platform}


%install
make install/fast DESTDIR=%{buildroot} -C %{_target_platform}

# inotify hackery
rm -fv %{buildroot}%{_sysconfdir}/dbus-1/system.d/org.kde.nepomuk.filewatch.conf
rm -fv %{buildroot}%{_datadir}/dbus-1/system-services/org.kde.nepomuk.filewatch.service
rm -fv %{buildroot}%{_kde4_libexecdir}/kde_nepomuk_filewatch_raiselimit
rm -fv %{buildroot}%{_polkit_qt_policydir}/org.kde.nepomuk.filewatch.policy


%check
desktop-file-validate %{buildroot}%{_kde4_datadir}/applications/kde4/nepomukbackup.desktop
%if 0%{?tests}
time xvfb-run -a dbus-launch --exit-with-session make test ARGS="--output-on-failure --timeout 300" -C %{_target_platform}/ ||:
%endif


%files
%doc ontologies/README COPYING.LGPL*
%{_kde4_appsdir}/fileindexerservice/
%{_kde4_appsdir}/nepomukfilewatch/
%{_kde4_appsdir}/nepomukstorage/
%{_kde4_bindir}/nepomuk-simpleresource-rcgen
%{_kde4_bindir}/nepomukbackup
%{_kde4_bindir}/nepomukbaloomigrator
%{_kde4_bindir}/nepomukcleaner
%{_kde4_bindir}/nepomukindexer
%{_kde4_bindir}/nepomukserver
%{_kde4_bindir}/nepomukservicestub
%{_kde4_bindir}/nepomuk2-rcgen
%{_kde4_bindir}/nepomukcmd
%{_kde4_bindir}/nepomukctl
%{_kde4_bindir}/nepomukfileindexer
%{_kde4_bindir}/nepomukfilewatch
%{_kde4_bindir}/nepomukmigrator
%{_kde4_bindir}/nepomuksearch
%{_kde4_bindir}/nepomukshow
%{_kde4_bindir}/nepomukstorage
%{_kde4_libdir}/libkdeinit4_nepomukserver.so
%{_kde4_datadir}/applications/kde4/nepomukbackup.desktop
%{_kde4_datadir}/applications/kde4/nepomukcleaner.desktop
%{_kde4_datadir}/autostart/nepomukbaloomigrator.desktop
%{_kde4_datadir}/autostart/nepomukserver.desktop
%{_kde4_datadir}/kde4/services/*.desktop
%{_kde4_datadir}/kde4/servicetypes/nepomukservice.desktop
%{_kde4_datadir}/kde4/servicetypes/nepomukextractor.desktop
%{_kde4_datadir}/ontology/kde/
%{_datadir}/dbus-1/interfaces/*.xml
#{_sysconfdir}/dbus-1/system.d/org.kde.nepomuk.filewatch.conf
#{_datadir}/dbus-1/system-services/org.kde.nepomuk.filewatch.service
#{_kde4_libexecdir}/kde_nepomuk_filewatch_raiselimit
#{_polkit_qt_policydir}/org.kde.nepomuk.filewatch.policy
%{_kde4_datadir}/kde4/servicetypes/nepomukcleaningjob.desktop
%{_kde4_datadir}/kde4/servicetypes/nepomukservice2.desktop
# metadata extractor plugins
# some of these (poppler, taglib) are good candidates to move to subpkg(s) -- rex
%{_kde4_libdir}/kde4/nepomuk*extractor.so

%files devel
%{_kde4_libdir}/libnepomukcleaner.so
%{_kde4_libdir}/libnepomukcore.so
%{_kde4_libdir}/cmake/NepomukCore/
%{_kde4_includedir}/nepomuk2/
%{_kde4_includedir}/Nepomuk2/

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%files libs
%{_kde4_libdir}/libnepomukcommon.so
%{_kde4_libdir}/libnepomukcleaner.so.4*
%{_kde4_libdir}/libnepomukcore.so.4*
%{_kde4_libdir}/libnepomukextractor.so


%changelog
* Sat Nov 08 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.14.3-1
- 4.14.3

* Sat Oct 11 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.14.2-1
- 4.14.2

* Mon Sep 15 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.14.1-1
- 4.14.1

* Thu Aug 21 2014 Rex Dieter <rdieter@fedoraproject.org> 4.14.0-3
- .spec cleanup
- restore libnepomukcleaner.so symlink (#1132497)

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.14.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Thu Aug 14 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.14.0-1
- 4.14.0

* Tue Aug 05 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.13.97-1
- 4.13.97

* Mon Jul 14 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.13.3-1
- 4.13.3

* Mon Jun 09 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.13.2-1
- 4.13.2

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.13.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sun May 11 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.13.1-1
- 4.13.1

* Wed Apr 23 2014 Rex Dieter <rdieter@fedoraproject.org> 
- 4.13.0-2
- Obsoletes: nepomuk-core < 4.13.0-2 (upgrade path to baloo)
- drop inotify hackery (let baloo handle that)
- drop mobi support (for now)

* Sat Apr 12 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.13.0-1
- 4.13.0

* Thu Apr 03 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.12.97-1
- 4.12.97

* Sat Mar 22 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.12.95-1
- 4.12.95

* Mon Mar 17 2014 Rex Dieter <rdieter@fedoraproject.org> 4.12.90-1
- 4.12.90

* Sat Mar 01 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.12.3-1
- 4.12.3, disable tests

* Mon Feb 17 2014 Rex Dieter <rdieter@fedoraproject.org> 4.12.2-2
- (re)enable tests

* Fri Jan 31 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.12.2-1
- 4.12.2

* Fri Jan 10 2014 Rex Dieter <rdieter@fedoraproject.org> - 4.12.1-1
- 4.12.1

* Thu Dec 19 2013 Rex Dieter <rdieter@fedoraproject.org> 4.12.0-2
- disable tests

* Wed Dec 18 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.12.0-1
- 4.12.0

* Wed Dec 11 2013 Rex Dieter <rdieter@fedoraproject.org> 4.11.97-4
- %%check: BR: procps (for ps)

* Wed Dec 11 2013 Rex Dieter <rdieter@fedoraproject.org> 4.11.97-3
- %%check harder

* Tue Dec 03 2013 Rex Dieter <rdieter@fedoraproject.org> 4.11.97-2
- rebuild (exiv2)

* Sun Dec 01 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.11.97-1
- 4.11.97

* Thu Nov 21 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.11.95-1
- 4.11.95

* Sat Nov 16 2013 Rex Dieter <rdieter@fedoraproject.org> 4.11.90-2
- enable mobipocket support

* Fri Nov 15 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.11.90-1
- 4.11.90

* Fri Nov 01 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.11.3-1
- 4.11.3

* Thu Oct 10 2013 Rex Dieter <rdieter@fedoraproject.org> 4.11.2-3
- rebuild (soprano)

* Thu Oct 10 2013 Rex Dieter <rdieter@fedoraproject.org> 4.11.2-2
- enable tests

* Sat Sep 28 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.11.2-1
- 4.11.2

* Tue Sep 03 2013 Rex Dieter <rdieter@fedoraproject.org> 4.11.1-1
- 4.11.1

* Fri Aug 30 2013 Rex Dieter <rdieter@fedoraproject.org> 4.11.0-3
- enable (verbose) tests

* Mon Aug 12 2013 Rex Dieter <rdieter@fedoraproject.org> 4.11.0-2
- respin

* Thu Aug 08 2013 Than Ngo <than@redhat.com> - 4.11.0-1
- 4.11.0

* Fri Aug 02 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.10.97-2
- pull in some upstream patches
- Requires: virtuoso-opensource >= 6.1.6

* Thu Jul 25 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.10.97-1
- 4.10.97

* Tue Jul 23 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.10.95-1
- 4.10.95

* Thu Jun 27 2013 Rex Dieter <rdieter@fedoraproject.org> 4.10.90-1
- 4.10.90

* Sat Jun 01 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.10.4-1
- 4.10.4

* Mon May 06 2013 Than Ngo <than@redhat.com> - 4.10.3-1
- 4.10.3

* Sun Mar 31 2013 Rex Dieter <rdieter@fedoraproject.org> 4.10.2-2
- tarball respin

* Sun Mar 31 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.10.2-1
- 4.10.2

* Thu Mar 21 2013 Rex Dieter <rdieter@fedoraproject.org> 4.10.1-2
- bump minimal exiv2 dep

* Sat Mar 02 2013 Rex Dieter <rdieter@fedoraproject.org> 4.10.1-1
- 4.10.1

* Fri Feb 08 2013 Rex Dieter <rdieter@fedoraproject.org> 4.10.0-2
- pull in a few upstream patches

* Thu Jan 31 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.10.0-1
- 4.10.0

* Sat Jan 19 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.9.98-1
- 4.9.98

* Fri Jan 04 2013 Rex Dieter <rdieter@fedoraproject.org> - 4.9.97-1
- 4.9.97

* Wed Dec 19 2012 Rex Dieter <rdieter@fedoraproject.org> - 4.9.95-1
- 4.9.95

* Fri Dec 07 2012 Rex Dieter <rdieter@fedoraproject.org> 4.9.90-2
- s|/etc/sysctl.d|/usr/lib/sysctl.d|

* Mon Dec 03 2012 Rex Dieter <rdieter@fedoraproject.org> 4.9.90-1
- 4.9.90 (4.10beta2)

* Mon Dec 03 2012 Than Ngo <than@redhat.com> - 4.9.4-1
- 4.9.4

* Fri Nov 02 2012 Rex Dieter <rdieter@fedoraproject.org> - 4.9.3-1
- 4.9.3

* Wed Oct 03 2012 Rex Dieter <rdieter@fedoraproject.org> 4.9.2-5
- respin isEmpty_crash based on 32b44881 upstream commit (#858271)

* Tue Oct 02 2012 Rex Dieter <rdieter@fedoraproject.org> 4.9.2-4
- respin isEmpty_crash patch to guard against NULL (#858271)

* Tue Oct 02 2012 Rex Dieter <rdieter@fedoraproject.org> 4.9.2-3
- sysctl.d/nepomuk-inotify.conf: fs.inotify.max_user_watches=524288 (f18+)

* Mon Oct 01 2012 Rex Dieter <rdieter@fedoraproject.org> 4.9.2-2
- proposed patch to fix/workaround isEmpty crash (#858271)

* Fri Sep 28 2012 Rex Dieter <rdieter@fedoraproject.org> - 4.9.2-1
- 4.9.2

* Mon Sep 03 2012 Than Ngo <than@redhat.com> - 4.9.1-1
- 4.9.1

* Fri Aug 10 2012 Rex Dieter <rdieter@fedoraproject.org> 
- 4.9.0-3.20120810git
- sync 4.9-branch patches
- %%check: do autotests
- Requires: +soprano-backend-virtuoso +virtuoso-opensource

* Thu Aug 02 2012 Rex Dieter <rdieter@fedoraproject.org> 4.9.0-2
- respin

* Thu Jul 26 2012 Lukas Tinkl <ltinkl@redhat.com> - 4.9.0-1
- 4.9.0

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.8.97-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Wed Jul 11 2012 Rex Dieter <rdieter@fedoraproject.org> - 4.8.97-1
- 4.8.97

* Wed Jun 27 2012 Jaroslav Reznik <jreznik@redhat.com> - 4.8.95-1
- 4.8.95

* Tue Jun 12 2012 Rex Dieter <rdieter@fedoraproject.org> 
- 4.8.90-2
- move libkdeinit_* to base pkg (no need for multilib) 
- .spec cleanup
- add shared-desktop-ontologies, soprano runtime deps

* Sat Jun 09 2012 Rex Dieter <rdieter@fedoraproject.org> - 4.8.90-1
- 4.8.90

* Fri Jun 01 2012 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.8.80-4
- BR kdelibs4-devel instead of kdelibs-devel, fixes minimum version (no Epoch)

* Fri Jun 01 2012 Jaroslav Reznik <jreznik@redhat.com> 4.8.80-3
- respin

* Wed May 30 2012 Jaroslav Reznik <jreznik@redhat.com> 4.8.80-2
- split -libs
- fix license

* Sat May 26 2012 Jaroslav Reznik <jreznik@redhat.com> 4.8.80-1
- initial try
